unit Unit1 ;

{$mode objfpc}{$H+}

interface

uses
  Classes , SysUtils , FileUtil , SpinEx , RTTICtrls , Forms , Controls ,
  Graphics , Dialogs , DBGrids , ExtCtrls , DbCtrls , Spin , StdCtrls ,
  ActnList , db , IBConnection , FBEventMonitor , sqldb ;

type

  { TForm1 }

  TForm1 = class ( TForm )
    DataSource1 : TDataSource ;
    DBGrid1: TDBGrid;
    IBConnection1 : TIBConnection ;
    Label1 : TLabel ;
    Panel1 : TPanel ;
    Panel2 : TPanel ;
    SpinEdit1 : TSpinEdit ;
    SQLQuery1 : TSQLQuery ;
    SQLTransaction1 : TSQLTransaction ;
    Timer1 : TTimer ;
    ToggleBox1 : TToggleBox ;
    procedure FormCreate ( Sender : TObject ) ;
    procedure SpinEdit1Change ( Sender : TObject ) ;
    procedure Timer1Timer ( Sender : TObject ) ;
    procedure ToggleBox1Click ( Sender : TObject ) ;
  private
    FFrequency : Integer;
    procedure DBReconnect;
    procedure TxnRestart;
  public

  end ;

var
  Form1 : TForm1 ;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1 .SpinEdit1Change ( Sender : TObject ) ;
begin
  if (Sender as TSpinEdit).Value = 0 then
    Timer1.Enabled:= false
  else begin
    Timer1.Enabled:= true;
    FFrequency := (Sender as TSpinEdit).Value * 1000;
    Timer1.Interval := FFrequency;
  end;
end;

procedure TForm1 .Timer1Timer ( Sender : TObject ) ;
begin
  if IBConnection1.Connected then
    TxnRestart;
end;


procedure TForm1.ToggleBox1Click ( Sender : TObject ) ;
begin
  try
    if IBConnection1.Connected then begin
      SQLTransaction1.Commit;
      IBConnection1.Connected := False;
    end
    else
      DBReconnect;
  finally
    if IBConnection1.Connected then
      ToggleBox1.Caption := 'Disconnect'
    else
      ToggleBox1.Caption := 'Connect';
  end ;
end;

procedure TForm1.DBReconnect ;
begin

  if IBConnection1.Connected then begin
    SQLTransaction1.Commit;
    IBConnection1.Connected := False;
  end;

  IBConnection1.Connected := True;
  SQLTransaction1.StartTransaction;
  SQLQuery1.Active := True;

end ;

procedure TForm1.TxnRestart ;
begin
  if IBConnection1.Connected then begin
    SQLQuery1.Active := False;
    SQLTransaction1.Commit;
    SQLTransaction1.StartTransaction;
    SQLQuery1.Active := True;
  end;
end ;


procedure TForm1.FormCreate ( Sender : TObject ) ;
begin
  FFrequency := 5 * 1000;
  Timer1.Interval := FFrequency;
end;

end .

